/* File: my_vector.h   -*- c++ -*-  */
/*  Author: Suvrit Sra <suvrit@tuebingen.mpg.de> */
/*  (c) Copyright 2006,2007   Suvrit Sra */
/*  Max-Planck-Institute for Biological Cybernetics */

// Time-stamp: <29 November 2007 01:59:27  CET --  suvrit>

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef _MY_VECTOR_H_
#define _MY_VECTOR_H_

template <typename ValType> class my_vector {
  size_t n;
  ValType* data;
public:
  my_vector() { n = 0; data = 0;}
  my_vector(size_t n) { this->n = n; data = new ValType[n];}
  ~my_vector() { delete [] data;}

  ValType operator [] (size_t i) { return data[i];}
  ValType get(size_t i) { return data[i];}
  void    set(size_t i, ValType v) { data[i] = v;}
  ValType* get_data() { return data;}
};

#endif // _MY_VECTOR_H_
